package com.utopiaindustries.model.ctp;

import java.math.BigDecimal;
import java.util.List;
import java.util.Objects;

public class JobCardItem {
    private long id;
    private long jobCardId;
    private long itemId;
    private String sku;
    private BigDecimal expectedProductionQuantity;
    private BigDecimal totalProduction;
    private BigDecimal production;
    // wrapper
    private List<CutPiece> cutPieces;
    private String title;

    public JobCardItem() {
        this.expectedProductionQuantity = BigDecimal.ZERO;
        this.totalProduction = BigDecimal.ZERO;
        this.production = BigDecimal.ZERO;
    }

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }

    public long getJobCardId() {
        return jobCardId;
    }

    public void setJobCardId(long jobCardId) {
        this.jobCardId = jobCardId;
    }

    public long getItemId() {
        return itemId;
    }

    public void setItemId(long itemId) {
        this.itemId = itemId;
    }

    public String getSku() {
        return sku;
    }

    public void setSku(String sku) {
        this.sku = sku;
    }

    public BigDecimal getExpectedProductionQuantity() {
        return expectedProductionQuantity;
    }

    public void setExpectedProductionQuantity(BigDecimal expectedProductionQuantity) {
        this.expectedProductionQuantity = expectedProductionQuantity;
    }

    public List<CutPiece> getCutPieces() {
        return cutPieces;
    }

    public void setCutPieces(List<CutPiece> cutPieces) {
        this.cutPieces = cutPieces;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public BigDecimal getTotalProduction() {
        return totalProduction;
    }

    public void setTotalProduction(BigDecimal totalProduction) {
        this.totalProduction = totalProduction;
    }

    public BigDecimal getProduction() {
        return production;
    }

    public void setProduction(BigDecimal production) {
        this.production = production;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        JobCardItem item = (JobCardItem) o;
        return id == item.id;
    }

    @Override
    public int hashCode() {
        return Objects.hash(id);
    }

    @Override
    public String toString() {
        return "JobCardItem{" +
                "id=" + id +
                ", jobCardId=" + jobCardId +
                ", itemId=" + itemId +
                ", sku='" + sku + '\'' +
                ", expectedProductionQuantity=" + expectedProductionQuantity +
                ", cutPieces=" + cutPieces +
                ", title='" + title + '\'' +
                '}';
    }
}
