package com.utopiaindustries.restcontroller;

import com.utopiaindustries.dao.ctp.StitchingOfflineItemDAO;
import com.utopiaindustries.model.ctp.StitchingOfflineItem;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping( "/rest/stitching-offline-items" )
public class StitchingItemsRestController {

    private final StitchingOfflineItemDAO stitchingOfflineItemDAO;

    public StitchingItemsRestController(StitchingOfflineItemDAO stitchingOfflineItemDAO) {
        this.stitchingOfflineItemDAO = stitchingOfflineItemDAO;
    }

    @GetMapping( "/search" )
    public List<StitchingOfflineItem> searchFinishedItems(@RequestParam( "term") String term ){
        return stitchingOfflineItemDAO.findByTerm( term );
    }
}
